Index: trunk/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 503)
@@ -5,4 +5,12 @@
    !!                 planetary vorticity trends
    !!======================================================================
+   !! History :  1.0  !  89-12  (P. Andrich)  vor_ens: Original code
+   !!            5.0  !  91-11  (G. Madec) vor_ene, vor_mix: Original code
+   !!            6.0  !  96-01  (G. Madec)  s-coord, suppress work arrays
+   !!            8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!            8.5  !  04-02  (G. Madec)  vor_een: Original code
+   !!            9.0  !  03-08  (G. Madec)  vor_ctl: Original code
+   !!            9.0  !  05-11  (G. Madec)  dyn_vor: Original code (new step architecture)
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -14,28 +22,25 @@
    !!       vor_ctl : control of the different vorticity option
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE in_out_manager  ! I/O manager
-   USE trdmod          ! ocean dynamics trends 
-   USE trdmod_oce      ! ocean variables trends
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE prtctl          ! Print control
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE trdmod         ! ocean dynamics trends 
+   USE trdmod_oce     ! ocean variables trends
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl         ! Print control
+   USE in_out_manager ! I/O manager
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC dyn_vor      ! routine called by step.F90
-
-   !! * Shared module variables
+   PUBLIC   dyn_vor   ! routine called by step.F90
+
+   !!* Namelist nam_dynvor: vorticity term
    LOGICAL, PUBLIC ::   ln_dynvor_ene = .FALSE.   !: energy conserving scheme
    LOGICAL, PUBLIC ::   ln_dynvor_ens = .TRUE.    !: enstrophy conserving scheme
    LOGICAL, PUBLIC ::   ln_dynvor_mix = .FALSE.   !: mixed scheme
-   LOGICAL, PUBLIC ::   ln_dynvor_een = .FALSE.    !: energy and enstrophy conserving scheme
-
-   !! * module variables
-   INTEGER ::                        &
-      nvor = 0                         ! type of vorticity trend used
+   LOGICAL, PUBLIC ::   ln_dynvor_een = .FALSE.   !: energy and enstrophy conserving scheme
+   NAMELIST/nam_dynvor/ ln_dynvor_ens, ln_dynvor_ene, ln_dynvor_mix, ln_dynvor_een
+
+   INTEGER ::   nvor = 0   ! type of vorticity trend used
 
    !! * Substitutions
@@ -43,5 +48,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -54,15 +61,11 @@
       !!
       !! ** Action : - Update (ua,va) with the now vorticity term trend
-      !!             - save the trends in (utrd,vtrd) in 2 parts (relative
+      !!             - save the trends in (ztrdu,ztrdv) in 2 parts (relative
       !!               and planetary vorticity trends) ('key_trddyn')
-      !!
-      !! History :
-      !!   9.0  !  05-11  (G. Madec)  Original code
-      !!----------------------------------------------------------------------
-      USE oce, ONLY :    ztrdu => ta,     & ! use ta as 3D workspace
-                         ztrdv => sa        ! use sa as 3D workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   ztrdu => ta   ! use ta as 3D workspace
+      USE oce, ONLY :   ztrdv => sa   ! use sa as 3D workspace
+      !!
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!----------------------------------------------------------------------
 
@@ -74,15 +77,15 @@
       CASE ( -1 )                                      ! esopa: test all possibility with control print
          CALL vor_ene( kt, 'TOT', ua, va )
-         IF(ln_ctl) CALL prt_ctl( tab3d_1=ua, clinfo1=' vor0 - Ua: ', mask1=umask, &
-            &                     tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+         CALL prt_ctl( tab3d_1=ua, clinfo1=' vor0 - Ua: ', mask1=umask, &
+            &          tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
          CALL vor_ens( kt, 'TOT', ua, va )
-         IF(ln_ctl) CALL prt_ctl( tab3d_1=ua, clinfo1=' vor1 - Ua: ', mask1=umask, &
-            &                     tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+         CALL prt_ctl( tab3d_1=ua, clinfo1=' vor1 - Ua: ', mask1=umask, &
+            &          tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
          CALL vor_mix( kt )
-         IF(ln_ctl) CALL prt_ctl( tab3d_1=ua, clinfo1=' vor2 - Ua: ', mask1=umask, &
-            &                     tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+         CALL prt_ctl( tab3d_1=ua, clinfo1=' vor2 - Ua: ', mask1=umask, &
+            &          tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
          CALL vor_een( kt, 'TOT', ua, va )
-         IF(ln_ctl) CALL prt_ctl( tab3d_1=ua, clinfo1=' vor3 - Ua: ', mask1=umask, &
-            &                     tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
+         CALL prt_ctl( tab3d_1=ua, clinfo1=' vor3 - Ua: ', mask1=umask, &
+            &          tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
 
       CASE ( 0 )                                       ! energy conserving scheme
@@ -93,5 +96,5 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdv, jpdtdrvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_rvo, 'DYN', kt )
             ztrdu(:,:,:) = ua(:,:,:)
             ztrdv(:,:,:) = va(:,:,:)
@@ -99,6 +102,6 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdu, jpdtdpvo, 'DYN', kt )
-            CALL trd_mod( ztrdu, ztrdv, jpdtddat, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdu, jpdyn_trd_pvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_dat, 'DYN', kt )
          ELSE
             CALL vor_ene( kt, 'TOT', ua, va )                ! total vorticity
@@ -112,5 +115,5 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdv, jpdtdrvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_rvo, 'DYN', kt )
             ztrdu(:,:,:) = ua(:,:,:)
             ztrdv(:,:,:) = va(:,:,:)
@@ -118,6 +121,6 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdu, jpdtdpvo, 'DYN', kt )
-            CALL trd_mod( ztrdu, ztrdv, jpdtddat, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdu, jpdyn_trd_pvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_dat, 'DYN', kt )
          ELSE
             CALL vor_ens( kt, 'TOT', ua, va )                ! total vorticity
@@ -131,5 +134,5 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdv, jpdtdrvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_rvo, 'DYN', kt )
             ztrdu(:,:,:) = ua(:,:,:)
             ztrdv(:,:,:) = va(:,:,:)
@@ -137,6 +140,6 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdu, jpdtdpvo, 'DYN', kt )
-            CALL trd_mod( ztrdu, ztrdv, jpdtddat, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdu, jpdyn_trd_pvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_dat, 'DYN', kt )
          ELSE
             CALL vor_mix( kt )                               ! total vorticity (mix=ens-ene)
@@ -150,5 +153,5 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdv, jpdtdrvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_rvo, 'DYN', kt )
             ztrdu(:,:,:) = ua(:,:,:)
             ztrdv(:,:,:) = va(:,:,:)
@@ -156,6 +159,6 @@
             ztrdu(:,:,:) = ua(:,:,:) - ztrdu(:,:,:)
             ztrdv(:,:,:) = va(:,:,:) - ztrdv(:,:,:)
-            CALL trd_mod( ztrdu, ztrdu, jpdtdpvo, 'DYN', kt )
-            CALL trd_mod( ztrdu, ztrdv, jpdtddat, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdu, jpdyn_trd_pvo, 'DYN', kt )
+            CALL trd_mod( ztrdu, ztrdv, jpdyn_trd_dat, 'DYN', kt )
          ELSE
             CALL vor_een( kt, 'TOT', ua, va )                ! total vorticity
@@ -192,30 +195,19 @@
       !!
       !! ** Action : - Update (ua,va) with the now vorticity term trend
-      !!             - save the trends in (utrd,vtrd) in 2 parts (relative
+      !!             - save the trends in (ztrdu,ztrdv) in 2 parts (relative
       !!               and planetary vorticity trends) ('key_trddyn')
       !!
-      !! References :
-      !!      Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
-      !! History :
-      !!   5.0  !  91-11  (G. Madec)  Original code
-      !!   6.0  !  96-01  (G. Madec)  s-coord, suppress work arrays
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
-      CHARACTER(len=3) , INTENT( in ) ::   &
-         cd_vor        ! define the vorticity considered
-         !             ! ='COR' (planetary) ; ='VOR' (relative) ; ='TOT' (total)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-         pua, pva                      ! ????
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk               ! dummy loop indices
-      REAL(wp) ::   &
-         zfact2,                         &  ! temporary scalars
-         zx1, zx2, zy1, zy2                 !    "         "
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zwx, zwy, zwz                      ! temporary workspace
+      !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
+      !!----------------------------------------------------------------------
+      INTEGER          , INTENT(in   )                         ::   kt       ! ocean time-step index
+      CHARACTER(len=3) , INTENT(in   )                         ::   cd_vor   ! ='COR' (planetary) ; ='VOR' (relative)
+         !                                                                   ! ='TOT' (total)
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua      ! total u-trend
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva      ! total v-trend
+      !!
+      INTEGER  ::   ji, jj, jk         ! dummy loop indices
+      REAL(wp) ::   zx1, zy1, zfact2   ! temporary scalars
+      REAL(wp) ::   zx2, zy2           !    "         "
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwx, zwy, zwz   ! temporary 2D workspace
       !!----------------------------------------------------------------------
 
@@ -234,14 +226,10 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-         
          ! Potential vorticity and horizontal fluxes
          ! -----------------------------------------
          SELECT CASE( cd_vor )      ! vorticity considered
-         CASE ( 'COR' )                   ! planetary vorticcity (Coriolis)
-            zwz(:,:) = ff(:,:)
-         CASE ( 'VOR' )                   ! relative  vorticity
-            zwz(:,:) = rotn(:,:,jk)
-         CASE ( 'TOT' )                   ! total     vorticity (planetary + relative)
-            zwz(:,:) = rotn(:,:,jk) + ff(:,:)
+         CASE ( 'COR' )   ;   zwz(:,:) =                  ff(:,:)      ! planetary vorticity (Coriolis)
+         CASE ( 'VOR' )   ;   zwz(:,:) =   rotn(:,:,jk)                ! relative  vorticity
+         CASE ( 'TOT' )   ;   zwz(:,:) = ( rotn(:,:,jk) + ff(:,:) )    ! total     vorticity 
          END SELECT
 
@@ -270,5 +258,4 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
    END SUBROUTINE vor_ene
 
@@ -300,25 +287,15 @@
       !!
       !! ** Action : - Update (ua,va) arrays with the now vorticity term trend
-      !!             - Save the trends in (utrd,vtrd) in 2 parts (relative
+      !!             - Save the trends in (ztrdu,ztrdv) in 2 parts (relative
       !!               and planetary vorticity trends) ('key_trddyn')
       !!
-      !! References :
-      !!      Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
-      !! History :
-      !!   5.0  !  91-11  (G. Madec) Original code, enstrophy-energy-combined schemes
-      !!   6.0  !  96-01  (G. Madec) s-coord, suppress work arrays
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt         ! ocean timestep index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk               ! dummy loop indices
-      REAL(wp) ::   &
-         zfact1, zfact2, zua, zva,       &  ! temporary scalars
-         zcua, zcva, zx1, zx2, zy1, zy2
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zwx, zwy, zwz, zww                 ! temporary workspace
+      !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean timestep index
+      !!
+      INTEGER ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zfact1, zua, zcua, zx1, zy1   ! temporary scalars
+      REAL(wp) ::   zfact2, zva, zcva, zx2, zy2   !    "         "
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwx, zwy, zwz, zww   ! temporary 3D workspace
       !!----------------------------------------------------------------------
 
@@ -367,5 +344,5 @@
                zcua = zfact2 * ( zwz(ji  ,jj-1) * zy1 + zwz(ji,jj) * zy2 )
                zcva =-zfact2 * ( zwz(ji-1,jj  ) * zx1 + zwz(ji,jj) * zx2 )
-
+               ! mixed vorticity trend added to the momentum trends
                ua(ji,jj,jk) = ua(ji,jj,jk) + zcua + zua
                va(ji,jj,jk) = va(ji,jj,jk) + zcva + zva
@@ -375,5 +352,4 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
    END SUBROUTINE vor_mix
 
@@ -400,29 +376,18 @@
       !!
       !! ** Action : - Update (ua,va) arrays with the now vorticity term trend
-      !!             - Save the trends in (utrd,vtrd) in 2 parts (relative 
+      !!             - Save the trends in (ztrdu,ztrdv) in 2 parts (relative 
       !!               and planetary vorticity trends) ('key_trddyn')
       !!
-      !! References :
-      !!      Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
-      !! History :
-      !!   5.0  !  91-11  (G. Madec)  Original code
-      !!   6.0  !  96-01  (G. Madec)  s-coord, suppress work arrays
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt    ! ocean timestep
-      CHARACTER(len=3) , INTENT( in ) ::   &
-         cd_vor        ! define the vorticity considered
-         !             ! ='COR' (planetary) ; ='VOR' (relative) ; ='TOT' (total)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-         pua, pva                      ! ????
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk          ! dummy loop indices
-      REAL(wp) ::   &
-         zfact1, zuav, zvau            ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zwx, zwy, zwz                 ! temporary workspace
+      !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
+      !!----------------------------------------------------------------------
+      INTEGER          , INTENT(in   )                         ::   kt       ! ocean time-step index
+      CHARACTER(len=3) , INTENT(in   )                         ::   cd_vor   ! ='COR' (planetary) ; ='VOR' (relative)
+         !                                                                   ! ='TOT' (total)
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua      ! total u-trend
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva      ! total v-trend
+      !!
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices
+      REAL(wp) ::   zfact1, zuav, zvau   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwx, zwy, zwz   ! temporary 3D workspace
       !!----------------------------------------------------------------------
       
@@ -441,14 +406,10 @@
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
-
          ! Potential vorticity and horizontal fluxes
          ! -----------------------------------------
          SELECT CASE( cd_vor )      ! vorticity considered
-         CASE ( 'COR' )                   ! planetary vorticcity (Coriolis)
-            zwz(:,:) = ff(:,:)
-         CASE ( 'VOR' )                   ! relative  vorticity
-            zwz(:,:) = rotn(:,:,jk)
-         CASE ( 'TOT' )                   ! total     vorticity (planetary + relative)
-            zwz(:,:) = rotn(:,:,jk) + ff(:,:)
+         CASE ( 'COR' )   ;   zwz(:,:) =                  ff(:,:)      ! planetary vorticity (Coriolis)
+         CASE ( 'VOR' )   ;   zwz(:,:) =   rotn(:,:,jk)                ! relative  vorticity
+         CASE ( 'TOT' )   ;   zwz(:,:) = ( rotn(:,:,jk) + ff(:,:) )    ! total     vorticity 
          END SELECT
 
@@ -470,5 +431,4 @@
          ENDIF
 
-
          ! Compute and add the vorticity term trend
          ! ----------------------------------------
@@ -476,8 +436,7 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zuav = zfact1 / e1u(ji,jj) * ( zwy(ji  ,jj-1) + zwy(ji+1,jj-1)   &
-                                            + zwy(ji  ,jj  ) + zwy(ji+1,jj  ) )
+                  &                         + zwy(ji  ,jj  ) + zwy(ji+1,jj  ) )
                zvau =-zfact1 / e2v(ji,jj) * ( zwx(ji-1,jj  ) + zwx(ji-1,jj+1)   &
-                                            + zwx(ji  ,jj  ) + zwx(ji  ,jj+1) )
-
+                  &                         + zwx(ji  ,jj  ) + zwx(ji  ,jj+1) )
                pua(ji,jj,jk) = pua(ji,jj,jk) + zuav * ( zwz(ji  ,jj-1) + zwz(ji,jj) )
                pva(ji,jj,jk) = pva(ji,jj,jk) + zvau * ( zwz(ji-1,jj  ) + zwz(ji,jj) )
@@ -487,5 +446,4 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
    END SUBROUTINE vor_ens
 
@@ -509,33 +467,20 @@
       !!
       !! ** Action : - Update (ua,va) with the now vorticity term trend
-      !!             - save the trends in (utrd,vtrd) in 2 parts (relative
+      !!             - save the trends in (ztrdu,ztrdv) in 2 parts (relative
       !!               and planetary vorticity trends) ('key_trddyn')
       !!
-      !! References :
-      !!      Arakawa and Lamb 1980, A potential enstrophy and energy conserving
-      !!                             scheme for the Shallow water equations, 
-      !!                             Monthly Weather Review, vol. 109, p 18-36
-      !!
-      !! History :
-      !!   8.5  !  04-02  (G. Madec)  Original code
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt        ! ocean time-step index
-      CHARACTER(len=3) , INTENT( in ) ::   &
-         cd_vor        ! define the vorticity considered
-         !             ! ='COR' (planetary) ; ='VOR' (relative) ; ='TOT' (total)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
-         pua, pva                      ! ????
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk              ! dummy loop indices
-      REAL(wp) ::   &
-         zfac12, zua, zva                  ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zwx, zwy, zwz,                 &  ! temporary workspace
-         ztnw, ztne, ztsw, ztse            !    "           "
-      REAL(wp), DIMENSION(jpi,jpj,jpk), SAVE ::   &
-         ze3f
+      !! References : Arakawa and Lamb 1980, Mon. Wea. Rev., 109, 18-36
+      !!----------------------------------------------------------------------
+      INTEGER          , INTENT(in   )                         ::   kt       ! ocean time-step index
+      CHARACTER(len=3) , INTENT(in   )                         ::   cd_vor   ! ='COR' (planetary) ; ='VOR' (relative)
+         !                                                                   ! ='TOT' (total)
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pua      ! total u-trend
+      REAL(wp)         , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pva      ! total v-trend
+      !!
+      INTEGER ::   ji, jj, jk          ! dummy loop indices
+      REAL(wp) ::   zfac12, zua, zva   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zwx, zwy, zwz            ! temporary 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztnw, ztne, ztsw, ztse   ! temporary 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk), SAVE ::   ze3f
       !!----------------------------------------------------------------------
 
@@ -570,10 +515,7 @@
          ! -----------------------------------------
          SELECT CASE( cd_vor )      ! vorticity considered
-         CASE ( 'COR' )                   ! planetary vorticcity (Coriolis)
-            zwz(:,:) = ff(:,:) * ze3f(:,:,jk)
-         CASE ( 'VOR' )                   ! relative  vorticity
-            zwz(:,:) = rotn(:,:,jk) * ze3f(:,:,jk)
-         CASE ( 'TOT' )                   ! total     vorticity (planetary + relative)
-            zwz(:,:) = ( rotn(:,:,jk) + ff(:,:) ) * ze3f(:,:,jk)
+         CASE ( 'COR' )   ;   zwz(:,:) =                  ff(:,:)   * ze3f(:,:,jk)   ! planetary vorticity (Coriolis)
+         CASE ( 'VOR' )   ;   zwz(:,:) =   rotn(:,:,jk)             * ze3f(:,:,jk)   ! relative  vorticity
+         CASE ( 'TOT' )   ;   zwz(:,:) = ( rotn(:,:,jk) + ff(:,:) ) * ze3f(:,:,jk)   ! total     vorticity 
          END SELECT
 
@@ -599,5 +541,4 @@
             END DO
          END DO
-         
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -613,5 +554,4 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
    END SUBROUTINE vor_een
 
@@ -623,67 +563,49 @@
       !! ** Purpose :   Control the consistency between cpp options for
       !!      tracer advection schemes
-      !!
-      !! History :
-      !!   9.0  !  03-08  (G. Madec)  Original code
-      !!----------------------------------------------------------------------
-      !! * Local declarations
+      !!----------------------------------------------------------------------
       INTEGER ::   ioptio          ! temporary integer
-
-      NAMELIST/nam_dynvor/ ln_dynvor_ens, ln_dynvor_ene, ln_dynvor_mix, ln_dynvor_een
-      !!----------------------------------------------------------------------
-
-      ! Read Namelist nam_dynvor : Vorticity scheme options
-      ! ------------------------
-      REWIND ( numnam )
+      !!----------------------------------------------------------------------
+
+      REWIND ( numnam )               ! Read Namelist nam_dynvor : Vorticity scheme options
       READ   ( numnam, nam_dynvor )
 
-      ! Control of vorticity scheme options
-      ! -----------------------------------
-      ! Control print
-      IF(lwp) THEN
+      IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
          WRITE(numout,*) 'dyn:vor_ctl : vorticity term : read namelist and control the consistency'
          WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*) '              Namelist nam_dynvor : oice of the vorticity term scheme'
-         WRITE(numout,*) '                 energy    conserving scheme                ln_dynvor_ene = ', ln_dynvor_ene
-         WRITE(numout,*) '                 enstrophy conserving scheme                ln_dynvor_ens = ', ln_dynvor_ens
-         WRITE(numout,*) '                 mixed enstrophy/energy conserving scheme   ln_dynvor_mix = ', ln_dynvor_mix
-         WRITE(numout,*) '                 enstrophy and energy conserving scheme     ln_dynvor_een = ', ln_dynvor_een
+         WRITE(numout,*) '        Namelist nam_dynvor : oice of the vorticity term scheme'
+         WRITE(numout,*) '           energy    conserving scheme                ln_dynvor_ene = ', ln_dynvor_ene
+         WRITE(numout,*) '           enstrophy conserving scheme                ln_dynvor_ens = ', ln_dynvor_ens
+         WRITE(numout,*) '           mixed enstrophy/energy conserving scheme   ln_dynvor_mix = ', ln_dynvor_mix
+         WRITE(numout,*) '           enstrophy and energy conserving scheme     ln_dynvor_een = ', ln_dynvor_een
       ENDIF
 
-      ioptio = 0
-      IF( ln_dynvor_ene ) THEN
-         nvor = 0
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '              vorticity term : energy conserving scheme'
-         ioptio = ioptio + 1
+      ioptio = 0                     ! Control of vorticity scheme options
+      IF( ln_dynvor_ene )   ioptio = ioptio + 1
+      IF( ln_dynvor_ens )   ioptio = ioptio + 1
+      IF( ln_dynvor_mix )   ioptio = ioptio + 1
+      IF( ln_dynvor_een )   ioptio = ioptio + 1
+      IF( lk_esopa      )   ioptio =          1
+
+      IF( ioptio /= 1 ) CALL ctl_stop( ' use ONE and ONLY one vorticity scheme' )
+
+      !                              ! Set nvor
+      IF( ln_dynvor_ene )   nvor =  0
+      IF( ln_dynvor_ens )   nvor =  1
+      IF( ln_dynvor_mix )   nvor =  2
+      IF( ln_dynvor_een )   nvor =  3
+      IF( lk_esopa      )   nvor = -1
+      
+      IF(lwp) THEN                   ! Print the choice
+         WRITE(numout,*)
+         IF( nvor ==  0 )   WRITE(numout,*) '         vorticity term used : energy conserving scheme'
+         IF( nvor ==  1 )   WRITE(numout,*) '         vorticity term used : enstrophy conserving scheme'
+         IF( nvor ==  2 )   WRITE(numout,*) '         vorticity term used : mixed enstrophy/energy conserving scheme'
+         IF( nvor ==  3 )   WRITE(numout,*) '         vorticity term used : energy and enstrophy conserving scheme'
+         IF( nvor == -1 )   WRITE(numout,*) '         esopa test: use all lateral physics options'
       ENDIF
-      IF( ln_dynvor_ens ) THEN
-         nvor = 1
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '              vorticity term : enstrophy conserving scheme'
-         ioptio = ioptio + 1
-      ENDIF
-      IF( ln_dynvor_mix ) THEN
-         nvor = 2
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '              vorticity term : mixed enstrophy/energy conserving scheme'
-         ioptio = ioptio + 1
-      ENDIF
-      IF( ln_dynvor_een ) THEN
-         nvor = 3
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '              vorticity term : energy and enstrophy conserving scheme'
-         ioptio = ioptio + 1
-      ENDIF
-      IF( ioptio /= 1 .AND. .NOT. lk_esopa ) CALL ctl_stop( ' use ONE and ONLY one vorticity scheme' )
-      IF( lk_esopa ) THEN
-         nvor = -1
-         IF(lwp ) WRITE(numout,*) '          esopa test: use all lateral physics options'
-      ENDIF
-      IF(lwp) WRITE(numout,*) '             choice of vor_...                nvor   = ', nvor
-
+      !
    END SUBROUTINE vor_ctl
 
-!!==============================================================================
+   !!==============================================================================
 END MODULE dynvor
